package test;
import static org.junit.Assert.*;
import static test.TDUListIterator3Test.getList;
import java.util.NoSuchElementException;
import kotae.Node;
import kotae.TDUListIterator3;
import kotae.TDUListIterator4;
import org.junit.Test;
public class TDUListIterator4Test {
	@Test
	public void testConstructor() {
		TDUListIterator4 listIterator = new TDUListIterator4((new Node<String>()),0);
		assertTrue(listIterator instanceof TDUListIterator3);
	}
	@Test(expected=NoSuchElementException.class)
	public void testNext() {
		Node<String> node= getList();
		TDUListIterator4 listIterator = new TDUListIterator4(node,0);
		assertTrue(listIterator.hasNext());
		assertEquals("abc",listIterator.next());
		assertTrue(listIterator.hasNext());
		assertEquals(null,listIterator.next());
		assertTrue(listIterator.hasNext());
		assertEquals("ghi",listIterator.next());
		assertFalse(listIterator.hasNext());
		listIterator.next();
	}
	@Test
	public void testNext2() {
		Node<String> node= getList();
		TDUListIterator4 listIterator = new TDUListIterator4(node,1);
		assertTrue(listIterator.hasNext());
		assertEquals(null,listIterator.next());
		listIterator.add("jkl");
		assertTrue(listIterator.hasNext());
		assertEquals("ghi",listIterator.next());
	}
}
