package test;
import static org.junit.Assert.*;
import static test.TDUListIterator3Test.*;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.NoSuchElementException;
import kadai.TDUList4;
import kotae.TDUListIterator3;
import org.junit.Test;
public class TDUList4Test {
	@Test
	public void testListIterator() {
		ListIterator<String> listIterator = (new TDUList4()).listIterator(0);
		Class<?> superClass= new TDUListIterator3(null, 0).getClass();
		assertEquals(superClass, listIterator.getClass().getSuperclass());
	}
	@Test
	public void test0() {
		TDUList4 list = new TDUList4();
		Iterator<String> iterator = list.iterator();
		assertFalse(iterator.hasNext());
	}
	@Test(expected=NoSuchElementException.class)
	public void test01() {
		TDUList4 list = new TDUList4();
		Iterator<String> iterator = list.iterator();
		assertFalse(iterator.hasNext());
		iterator.next();
	}
	@Test
	public void test3() {
		TDUList4 list = new TDUList4();
		list.node = getList();
		Iterator<String> iterator = list.iterator();
		assertTrue(iterator.hasNext());
		assertEquals("abc",iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals(null,iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals("ghi",iterator.next());
		assertFalse(iterator.hasNext());
	}
	@Test(expected=NoSuchElementException.class)
	public void testAdd(){
		TDUList4 list = new TDUList4();
		list.add("hij");
		list.add(null);
		list.add("nop");
		Iterator<String> iterator = list.iterator();
		assertTrue(iterator.hasNext());
		assertEquals("hij",iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals(null,iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals("nop",iterator.next());
		assertFalse(iterator.hasNext());
		iterator.next();
	}
}