package test;
import static org.junit.Assert.*;
import java.util.NoSuchElementException;
import kadai.TDUListIterator1;
import org.junit.Before;
import org.junit.Test;
public class TDUListIterator1Test {
	private TDUListIterator1 iterator;
	@Before
	public void setUp() throws Exception {
		iterator = new TDUListIterator1(null,0);
	}
	@Test(expected=UnsupportedOperationException.class)
	public void testAdd() {
		iterator.add(null);
		fail("This test must not reach here.");
	}
	@Test
	public void testHasNext() {
		assertFalse(iterator.hasNext());
	}
	@Test
	public void testHasPrevious() {
		assertFalse(iterator.hasPrevious());
	}
	@Test(expected=NoSuchElementException.class)
	public void testNext() {
		iterator.next();
		fail("This test must not reach here.");
	}
	@Test
	public void testNextIndex() {
		assertEquals(0,iterator.nextIndex());
	}
	@Test(expected=NoSuchElementException.class)
	public void testPrevious() {
		iterator.previous();
	}
	@Test
	public void testPreviousIndex() {
		assertEquals(-1,iterator.previousIndex());
	}
	@Test(expected=UnsupportedOperationException.class)
	public void testRemove() {
		iterator.remove();
		fail("This test must not reach here.");
	}
	@Test(expected=UnsupportedOperationException.class)
	public void testSet() {
		iterator.set(null);
		fail("This test must not reach here.");
	}
}
